﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Float {
  using Common;
  using Data;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class FloatConstantErcValue : ConstantsWeightedErcValue<double, DoubleArray> {

    public FloatConstantErcValue() : this(new double[0]) { }

    public FloatConstantErcValue(params double[] constants)
      : base(new DoubleArray(constants)) {
      Name = "Float constants";
    }

    [StorableConstructor]
    public FloatConstantErcValue(bool deserializing) : base(deserializing) { }

    public FloatConstantErcValue(FloatConstantErcValue origin, Cloner cloner) : base(origin, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new FloatConstantErcValue(this, cloner);
    }
  }
}
